#!/bin/sh
#usage mkaddon </path/to/BUILDDIRectory>
#this script makes an sfs addon from your pup_save file and much more to create new builddir_xxx.sfs file...and even mypuplet_XXX.iso
#adapted from /usr/sbin/remasterpup2 by Barry Kauler which uses less disk space but its too difficult for me to adapt

PUPPYVERSION="`cat /etc/puppyversion`"
# need to add check for empty dir and then make it go to /tmp/addon
#use a folder in /tmp or on a mounted drive for BUILDDIR
#if [ "$1" = "" ];then
#mkdir /tmp/build
#$BUILDDIR=/tmp/build
#else
BUILDDIR=$1
#fi
DIRNAME="`dirname $BUILDDIR`"

Xdialog --title "Puppy addon script" --yesno "The only SAFE way to run this program is to drag an empty folder to it from a separate mounted partition
If you choos YES all files in $BUILDDIR will be deleted" 0 0
if [ $? -eq 0 ];then
rm -rf $BUILDDIR/*
else
exit
fi

#Not sure if this will make an endless loop if BUILDDIR is in referenced in /initrd/pup_ro2/???
Xdialog --title "Puppy addon script" --yesno "Do you wish to include the original pup_XXX.sfs?" 0 0
if [ $? -eq 0 ];then
cp -arf /initrd/pup_ro2/* $BUILDDIR
NEWPUP=1
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include any extra sfs files you have loaded?" 0 0
if [ $? -eq 0 ];then
cp -arf /initrd/pup_ro3/* $BUILDDIR
cp -arf /initrd/pup_ro4/* $BUILDDIR
cp -arf /initrd/pup_ro5/* $BUILDDIR
cp -arf /initrd/pup_ro6/* $BUILDDIR
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include a loaded zdrv_XXX.sfs?" 0 0
if [ $? -eq 0 ];then
cp -arf /initrd/pup_z/* $BUILDDIR
INCLZDRV=1
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include the pet packages you have installed?" 0 0
if [ $? -eq 0 ];then
#.packages/ .files, copy any files installed
for ONEPKG in `ls -1 /initrd/pup_ro1/root/.packages/*.files 2> /dev/null | tr "\n" " "`
do
 for ONEFILE in `cat $ONEPKG | grep '^' | tr "\n" " "`
 do
  DIRNAME="`dirname $ONEFILE`"
  mkdir -p $BUILDDIR$DIRNAME
  cp -f $ONEFILE $BUILDDIR$DIRNAME/
 done
done
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include desktop customizations?" 0 0
if [ $? -eq 0 ];then
# had to set up these to stop errors with cp below - probably could be removed with the right cp command??
mkdir -p $BUILDDIR/root/.icewm/
mkdir -p $BUILDDIR/root/Choices/ROX-Filer/
mkdir -p $BUILDDIR/root/.jwm/
mkdir -p $BUILDDIR/root/.packages/
mkdir -p $BUILDDIR/root/my-applications/
mkdir -p $BUILDDIR/etc/X11/xinit/
# copy any changes in the pup_save file
cp -af /initrd/pup_ro1/usr/local/lib/X11 $BUILDDIR/usr/local/lib/X11
cp -af /initrd/pup_ro1/usr/share/backgrounds $BUILDDIR/usr/share/backgrounds
cp -af /initrd/pup_ro1/root/my-applications/* $BUILDDIR/root/my-applications/
cp -af /initrd/pup_ro1/root/my-roxapps $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.jwmrc $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.jwmrc-tray $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.fvwm95rc $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.icewm/menu $BUILDDIR/root/.icewm/
cp -af /initrd/pup_ro1/root/Choices/ROX-Filer/PuppyPin $BUILDDIR/root/Choices/ROX-Filer/
cp -af /initrd/pup_ro1/root/Choices/ROX-Filer/globicons $BUILDDIR/root/Choices/ROX-Filer/
grep -v '/initrd/pup_ro1/root/.pup_event/drive_' $BUILDDIR/root/Choices/ROX-Filer/PuppyPin > /tmp/remaster-PuppyPin
mv -f /tmp/remaster-PuppyPin $BUILDDIR/root/Choices/ROX-Filer/PuppyPin
cp -af /initrd/pup_ro1/root/.xinitrc $BUILDDIR/root/
[ -f /initrd/pup_ro1/root/.xset.sh ] && cp -af /initrd/pup_ro1/root/.xset.sh $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.gtkrc-2.0 $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.jwm/jwm_colors $BUILDDIR/root/.jwm/
cp -af /initrd/pup_ro1/root/.jwm/jwmrc-personal $BUILDDIR/root/.jwm/
cp -af /initrd/pup_ro1/root/.jwm/jwmrc-personal2 $BUILDDIR/root/.jwm/
cp -af /initrd/pup_ro1/root/.jwm/jwmrc-theme $BUILDDIR/root/.jwm/
cp -af /initrd/pup_ro1/root/.pmountauto $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.pmountengine $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.pmountquit $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.pmountsingle $BUILDDIR/root/
cp -af /initrd/pup_ro1/root/.packages/*.txt $BUILDDIR/root/.packages/
cp -af /initrd/pup_ro1/root/.packages/*.files $BUILDDIR/root/.packages/
cp -af /initrd/pup_ro1/etc/ld.so.conf $BUILDDIR/etc/
cp -af /initrd/pup_ro1/etc/init.d/* $BUILDDIR/etc/init.d/
cp -af /initrd/pup_ro1/etc/eventmanager $BUILDDIR/etc/
cp -af /initrd/pup_ro1/etc/windowmanager $BUILDDIR/etc/
cp -af /initrd/pup_ro1/etc/Puppybackgroundcolor $BUILDDIR/etc/
cp -af /initrd/pup_ro1/etc/Puppybackgroundpicture $BUILDDIR/etc/
cp -af /initrd/pup_ro1/etc/X11/xinit/* $BUILDDIR/etc/X11/xinit/
#copied again in case any changes were made this session
cp -af /initrd/pup_rw/usr/local/lib/X11 $BUILDDIR/usr/local/lib/X11
cp -af /initrd/pup_rw/usr/share/backgrounds $BUILDDIR/usr/share/backgrounds
cp -af /initrd/pup_rw/root/my-applications/* $BUILDDIR/root/my-applications/
cp -af /initrd/pup_rw/root/my-roxapps $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.jwmrc $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.jwmrc-tray $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.fvwm95rc $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.icewm/menu $BUILDDIR/root/.icewm/
cp -af /initrd/pup_rw/root/Choices/ROX-Filer/PuppyPin $BUILDDIR/root/Choices/ROX-Filer/
cp -af /initrd/pup_rw/root/Choices/ROX-Filer/globicons $BUILDDIR/root/Choices/ROX-Filer/
grep -v '/initrd/pup_rw/root/.pup_event/drive_' $BUILDDIR/root/Choices/ROX-Filer/PuppyPin > /tmp/remaster-PuppyPin
mv -f /tmp/remaster-PuppyPin $BUILDDIR/root/Choices/ROX-Filer/PuppyPin
cp -af /initrd/pup_rw/root/.xinitrc $BUILDDIR/root/
[ -f /initrd/pup_rw/root/.xset.sh ] && cp -af /initrd/pup_rw/root/.xset.sh $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.gtkrc-2.0 $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.jwm/jwm_colors $BUILDDIR/root/.jwm/
cp -af /initrd/pup_rw/root/.jwm/jwmrc-personal $BUILDDIR/root/.jwm/
cp -af /initrd/pup_rw/root/.jwm/jwmrc-personal2 $BUILDDIR/root/.jwm/
cp -af /initrd/pup_rw/root/.jwm/jwmrc-theme $BUILDDIR/root/.jwm/
cp -af /initrd/pup_rw/root/.pmountauto $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.pmountengine $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.pmountquit $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.pmountsingle $BUILDDIR/root/
cp -af /initrd/pup_rw/root/.packages/*.txt $BUILDDIR/root/.packages/
cp -af /initrd/pup_rw/root/.packages/*.files $BUILDDIR/root/.packages/
cp -af /initrd/pup_rw/etc/ld.so.conf $BUILDDIR/etc/
cp -af /initrd/pup_rw/etc/init.d/* $BUILDDIR/etc/init.d/
cp -af /initrd/pup_rw/etc/eventmanager $BUILDDIR/etc/
cp -af /initrd/pup_rw/etc/windowmanager $BUILDDIR/etc/
cp -af /initrd/pup_rw/etc/Puppybackgroundcolor $BUILDDIR/etc/
cp -af /initrd/pup_rw/etc/Puppybackgroundpicture $BUILDDIR/etc/
cp -af /initrd/pup_rw/etc/X11/xinit/* $BUILDDIR/etc/X11/xinit/
#may need more?
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include YOUR hardware specific customizations?" 0 0
if [ $? -eq 0 ];then
 cp -af /etc/codepage $BUILDDIR/etc/codepage
 cp -af /etc/fontmap $BUILDDIR/etc/fontmap
 cp -af /etc/keyboardtype $BUILDDIR/etc/
 cp -af /etc/keymap $BUILDDIR/etc/
 cp -af /etc/mousebuttons $BUILDDIR/etc/
 cp -af /etc/mousedevice $BUILDDIR/etc/
 cp -af /etc/videomode $BUILDDIR/etc/
 cp -af /etc/eth0mode $BUILDDIR/etc/
 cp -af /etc/eth1mode $BUILDDIR/etc/
 cp -af /etc/resolv.conf $BUILDDIR/etc/
 cp -af /etc/localtime $BUILDDIR/etc/
 cp -af /etc/TZ $BUILDDIR/etc/
 cp -af /etc/cdburnerdevice $BUILDDIR/etc/
 cp -af /etc/dvddevice $BUILDDIR/etc/
 cp -af /etc/modemdevice $BUILDDIR/etc/
 cp -af /etc/securetelnetrc $BUILDDIR/etc/
 cp -af /etc/modules.conf $BUILDDIR/etc/
 cp -af /etc/modprobe.conf $BUILDDIR/etc/
 cp -af /etc/rdesktoprc $BUILDDIR/etc/
 cp -af /etc/windowmanager $BUILDDIR/etc/
 cp -af /etc/xextraoptions $BUILDDIR/etc/
 cp -af /etc/X11/xorg.conf $BUILDDIR/etc/X11
 MSG1="These files were customised in /etc:
codepage fontmap keyboardtype keymap mousebuttons mousedevice videomode
eth0mode eth1mode resolv.conf localtime TZ cdburnerdevice dvddevice modemdevice
securetelnetrc modprobe.conf rdesktoprc windowmanager xextraoptions X11/xorg.conf
You will have to copy /etc/wvdial.conf manually (remove private info first)"
fi

Xdialog --title "Puppy addon script" --yesno "Do you wish to include & edit YOUR wvdial.conf settings?" 0 0
if [ $? -eq 0 ];then
 cp -af /etc/wvdial.conf $BUILDDIR/etc/
 defaulttexteditor $BUILDDIR/etc/wvdial.conf
fi

Xdialog --title "Last Chance" --msgbox "After pressing the ENTER button $BUILDDIR_$PUPPYVERSION.sfs will be made
Now is a good time to open extra sfs files that you don't have loaded and copy them to @BUIIDDIR
You can also manually add/edit anything else you want ... till you click OK
This is your last chance to edit $BUILDDIR
Note that it will probably take a long time" 0 0

#need to rm existing sfs
rxvt -bg orange -title "Building SFS" -e dir2sfs $BUILDDIR

Xdialog --title "sfs Build Finished" --msgbox "$BUILDDIR_$PUPPYVERSION.sfs is now in $DIRNAME" 0 0

if [ $NEWPUP = 1 ];then
Xdialog --title "Puppy remaster" --yesno "Do you wish to remaster the iso?" 0 0
if [ $? -eq 0 ];then
#delete files from BUILDDIR
rm -rf $BUILDDIR/*
#MANUALLY copy files from cd or iso or wherever
Xdialog --title "Manually copy files" --msgbox "Copy the files from your $PUPPYVERSION CD or iso and $BUILDDIR_$PUPPYVERSION.sfs to $BUILDDIR" 0 0
rm -rf $BUILDDIR/pup_$PUPPYVERSION.sfs
rm -rf $BUILDDIR/boot.cat
#cp $BUILDDIR_$PUPPYVERSION.sfs $BUILDDIR

#give chance to edit files
Xdialog --title "Puppy remaster" --yesno "Do you wish to edit isolinux.cfg (for boot options)?" 0 0
if [ $? -eq 0 ];then
defaulttexteditor $BUILDDIR/isolinux.cfg
fi
#editing may break it?
#defaulttexteditor $BUILDDIR/boot.msg
#others?

#delete bad file(s)
#don't put 2 zdrvs
if [ $INCLZDRV = 1 ];then
rm -rf $BUILDDIR/zdrv_$PUPPYVERSION.sfs
Xdialog --title "duplicate zdrv removed" --msgbox "zdrv_$PUPPYVERSION.iso was removed because you included it in the pup_$PUPPYVERSION.sfs
If you really want to add another zdrv file you will have to do it now
for instance if you have made/collected additional kernel modules etc
just put it in $BUILDDIR" 0 0
fi
#automatically built with mkisofs

Xdialog --title "Last Chance" --msgbox "Last chance to add files to $BUILDDIR before pressing ENTER or clicking OK" 0 0

#make iso
rxvt -bg orange -title "Puppy simple remaster CD" -e mkisofs -D -R -o $DIRNAME/mypuplet-$PUPPYVERSION.iso -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table $BUILDDIR
Xdialog --title "Finished making iso" --msgbox "mypuplet-$PUPPYVERSION.iso is now in $DIRNAME
burn & boot with pfix=ram to test it" 0 0

Xdialog --title "Puppy remaster" --yesno "Do you wish to burn the iso?" 0 0
if [ $? -eq 0 ];then
pburn $DIRNAME/mypuplet-$PUPPYVERSION.iso
fi

fi

#this is where to add usb install option for a zip file need to do research

fi

#EOF
